; ##############################################################################
; ##############################################################################
; ##############################################################################
EXTERNER_INTERUPT_INITIALISIEREN:
;																			
; SLEEP+INT0+INT1 (externer Interrupt) konfigurieren						
;																			
; MCUCR => SE SM2 SM1 SM0 ISC11 ISC10 ISC01 ISC00 							
; SM2 SM1 SM0 Sleep Mode													
;*0   0   0   Idle															
; 0   0   1   ADC Noise Reduction											
; 0   1   0   Power-down													
; 0   1   1   Power-save													
; 1   0   0   Reserved														
; 1   0   1   Reserved														
; 1   1   0   Standby(1)													
;																			
;ISC11 ISC10 Description													
; 0 	0 	The low level of INT1 generates an interrupt request.			
; 0 	1 	Any logical change on INT1 generates an interrupt request.		
;*1 	0 	The falling edge of INT1 generates an interrupt request.		
; 1 	1 	The rising edge of INT1 generates an interrupt request.			
;																			
;ISC01 ISC00 Description													
; 0 	0 	The low level of INT0 generates an interrupt request.			
; 0 	1 	Any logical change on INT0 generates an interrupt request.		
; 1 	0 	The falling edge of INT0 generates an interrupt request.		
; 1 	1 	The rising  edge of INT0 generates an interrupt request.		
;																			
	ldi temp,(1<<SE)|(0<<SM2)|(0<<SM1)|(0<<SM0)|(1<<ISC11)|(0<<ISC10)|(1<<ISC01)|(0<<ISC00) 
	out MCUCR,temp
	; DCF-EINGANG						
	cbi (E_50HZ_DDR) ,(E_50HZ_PIN_NR) ; auf EINGANG	
	cbi (E_50HZ_PORT),(E_50HZ_PIN_NR) ; PULL UP ein	
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
EXTERNER_INTERRUPT_AKTIVIEREN:
;																			
; INT0+INT1 (externer Interrupt)aktivieren									
;																			
; GICR => INT1 INT0 - - - - IVSEL IVCE 										
; General Interrupt Control													
;																			
	ldi temp, (0<<INT1)|(1<<INT0)|(0<<IVSEL)|(0<<IVCE)   
    out GICR, temp 
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
; 50Hz/100Hz Uhr																
EXT_INT0:
	push TEMP		    ; Sichern von "TEMP" im Stack
	in	 TEMP,SREG		; Einlesen des SREG 
	push TEMP	    	; Schreiben von  SREG  im Stack (KOPIE)
; -------------------------------
EXT_INT0_SS100:
	LDS temp,(adr_50HZ_ss100)	; laden		
	inc temp					; +1		
	cpi temp,100				; vergleich	
	brsh EXT_INT0_SS			; ist gleich/grer ==> Sprung	
	STS(adr_50HZ_ss100),temp	; speichern	
	rjmp EXT_INT0_FERTIG		; SPRUNG	

EXT_INT0_SS:
	STS(adr_50HZ_ss100),NULL

	LDS temp,(adr_50HZ_ss)
	inc temp
	cpi temp,60
	brsh EXT_INT0_MM
	STS(adr_50HZ_ss),temp
	rjmp EXT_INT0_FERTIG

EXT_INT0_MM:
	STS(adr_50HZ_ss),NULL

	LDS temp,(adr_50HZ_mm)
	inc temp
	cpi temp,60
	brsh EXT_INT0_HH
	STS(adr_50HZ_mm),temp
	rjmp EXT_INT0_FERTIG
EXT_INT0_HH:
	STS(adr_50HZ_mm),NULL

	LDS temp,(adr_50HZ_hh)
	inc temp
	cpi temp,24
	brsh EXT_INT0_TAG
	STS(adr_50HZ_hh),temp
	rjmp EXT_INT0_FERTIG

EXT_INT0_TAG:
	STS(adr_50HZ_hh),NULL
; -------------------------------
EXT_INT0_FERTIG:
	pop	TEMP			; LESEN von SREG vom STACK (KOPIE)
	out	SREG,TEMP		; Wiederherstellen von SREG
	pop	TEMP			; Wiederherstellen von "TEMP" 			
reti
; ##############################################################################
; ##############################################################################
; ##############################################################################
